{Main-Tool}
DEFINE Gdm_fill_table_from_file
  PARAMETER Ltab_name     {Name der logischen Tabelle}
  PARAMETER Datfile_name  {Name der Datendatei}
  PARAMETER Open_number   {Zugriffsnummer fuer Datendatei}
  PARAMETER Komment       {Kommentarzeichen}
  PARAMETER Trenn         {Spaltentrennzeichen}
  PARAMETER Del_or_append {Tabelle vorher loeschen oder nicht}

  LOCAL Error_test  {Variable ob alle Parameter den richtigen Typ haben}
  LOCAL Start_zeile {Variable fr erste zu fllende Zeile}
  LOCAL Spalte      {Spaltenwert}
  LOCAL Komplett_str {Gesamte Zeile aus Datei}
  LOCAL Rest_str     {Restliche Zeile nach Abzug der 1.Spalte}
  LOCAL Wert_str     {Wert fuer Tabelle}
  
  LET Error_test 1  
  {Parameter Check}
  IF ((TYPE Ltab_name)<>STRING)
     BEEP
     DISPLAY 'Tabellenname mu ein String sein !'
     CANCEL
  END_IF
  IF ((TYPE Datfile_name)<>STRING)
     BEEP
     DISPLAY 'Dateiname mu ein String sein !'
     CANCEL
  END_IF
  IF ((TYPE Open_number)<>NUMBER)
     BEEP
     DISPLAY 'Dateizugriffsnummer mu eine Zahl sein!'
     CANCEL
  END_IF
  IF (Open_number>10)
     BEEP
     DISPLAY 'Dateizugriffsnummer auerhalb gltigen Bereichs (1-10)'
     CANCEL
  END_IF
  IF ((TYPE Komment)<>STRING)
     BEEP
     DISPLAY 'Kommentarzeichen mu ein String sein !'
     CANCEL
  END_IF
  IF (((LEN Komment)>1))
     BEEP
     DISPLAY 'Kommentarzeichen darf nur 1 Zeichen lang sein !'
     CANCEL
  END_IF
  IF ((TYPE Trenn)<>STRING)
     BEEP
     DISPLAY 'Trennerzeichen mu ein String sein !'
     CANCEL
  END_IF
  IF (((LEN Trenn)>1))
     BEEP
     DISPLAY 'Das Trennerzeichen darf nur 1 character haben !'
     CANCEL
  END_IF
  IF ((TYPE Del_or_append)<>QUALIFIER)
     BEEP
     DISPLAY 'Die Startbedingung fuers Tabellenfuellen hat den falschen Typ'
     CANCEL
  END_IF
  IF (NOT ((Del_or_append=DEL_OLD)OR(Del_or_append=APPEND)))
     BEEP
     DISPLAY 'Die Startbedingung mu DEL_OLD oder APPEND lauten'
     CANCEL
  END_IF

  {Pruefen ob Tabelle vorhanden}
  TRAP_ERROR
  SELECT_FROM_LTAB Ltab_name COLUMN 1 = '*' END
  IF ((CHECK_ERROR)=1)
     BEEP
     DISPLAY ('Logische Tabelle : '+Ltab_name+' nicht gefunden')
     CANCEL
  END_IF
  LET Start_zeile (LTAB_ROWS Ltab_name)
  
  IF (Del_or_append = APPEND)
    LET Start_zeile ((LTAB_ROWS Ltab_name)+1)
  ELSE
    DELETE_LTAB_ROW Ltab_name ALL
    LET Start_zeile 1
  END_IF

  {Datei ffnen}
  TRAP_ERROR
  OPEN_INFILE Open_number Datfile_name
  IF ((CHECK_ERROR)=1)
     BEEP
     DISPLAY ('Konnte Datei : '+Datfile_name+' nicht oeffnen')
     CANCEL
  END_IF
  
  {Tabelle fuellen}
  LET Spalte 1
  LOOP
    READ_FILE Open_number Komplett_str
    LET Rest_str Komplett_str
  EXIT_IF (Komplett_str = 'END-OF-FILE')
    IF ((SUBSTR Komplett_str 1 1)<>Komment)
       LOOP
       EXIT_IF ((LEN Rest_str) = 0)
         IF ((POS Rest_str Trenn)<>0)
           LET Wert_str (SUBSTR Rest_str 1 ((POS Rest_str Trenn)-1))
           LET Rest_str (SUBSTR Rest_str ((POS Rest_str Trenn)+1) (LEN Rest_str))
         ELSE
           LET Wert_str Rest_str
           LET Rest_str ''
         END_IF
         WRITE_LTAB Ltab_name Start_zeile Spalte Wert_str
         {DISPLAY ('Zeile '+(STR Start_zeile)+' Spalte '+(STR Spalte)+ 'Wert '+Wert_str)}
         LET Spalte (Spalte+1)
       END_LOOP
       LET Start_zeile (Start_zeile+1)
       LET Spalte 1
    END_IF
  END_LOOP
CLOSE_FILE Open_number
END_DEFINE